<?php /*windu.org core*/
class lang
{
	private static $lang;
	public static $langFiles = array('admin.txt','front.txt');
	
	public static function set($bucket)
	{
		$pagesDB = new pagesDB();
		$lang = cookie::readCookie("lang-{$bucket}");
		
		if (is_numeric($lang)) {
			$langDir = strtolower($pagesDB->get($lang,'name'));
		}	

		if ($lang!='' and is_dir(DATA_PATH.'languages/' . $langDir . '/'))
		{
			define('LANG', $lang);
		}
		else
		{
			define('LANG', config::get('language-'.$bucket));
			$langDir = strtolower($pagesDB->get(LANG,'name'));
		}
			
		define('LANG_BUCKET', $bucket);

		if (!cache::isCached(LANG.$bucket.'langContent')) {
			cache::write(LANG.$bucket.'langContent', self::prepere($bucket,$langDir),'lang');
		}

	}
	public static function read($key)
	{
		$key = trim($key,' ');
		$data = cache::read(LANG.LANG_BUCKET.'langContent');
		
		//if (isset($data[$key]))return '[[['.$data[$key].']]]';
		//if (isset($data[$key]))return '';
		
		if (isset($data[$key]))return $data[$key];
		else return '?????? '.$key.' ??????';
		
		return 'No language file!';		
	}
	public static function exist($key) {
		$key = trim($key,' ');
		$data = cache::read(LANG.LANG_BUCKET.'langContent');
		if (isset($data[$key]))return true;
		else return false;
	}
	private static function prepere($bucket,$langName) {
		$pagesDB = new pagesDB();

		$langDir = strtolower($pagesDB->get(LANG,'name'));
		$mainArray = parse_ini_file(DATA_PATH . 'languages/' . $langDir . '/'.$bucket.'.txt',true);
		if ($bucket=='front') {
			$widgetsArray = array();
			$widgetsArray = widgetsDB::getLanguage($langName);
			$data = array_merge($mainArray,$widgetsArray);
		}else{
			$data = $mainArray;
		}

		return $data;
	}	

	public static function setLangByDomain(array $domainLang) {
		$actualDomain = str_replace('http://', '', __BASE);
		$actualDomain = str_replace('www.', '', $actualDomain);

		$langId = $domainLang[$actualDomain];
		if (is_numeric($langId)) {
			$pagesDB = new pagesDB();
			if($pagesDB->fetchCount("id={$langId}")==1){
				if (cookie::readCookie('lang-front')!=$langId) {
					cookie::setCookie('lang-front',$langId,1209600);
					exit;
					router::redirect('front');
				}
				
				return true;
			}
		}
		return false;
	}
	public static function preferedLanguage($available_languages,$http_accept_language="auto") { 

	    if ($http_accept_language == "auto") $http_accept_language = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? $_SERVER['HTTP_ACCEPT_LANGUAGE'] : ''; 

	    preg_match_all("/([[:alpha:]]{1,8})(-([[:alpha:]|-]{1,8}))?" . 
	                   "(\s*;\s*q\s*=\s*(1\.0{0,3}|0\.\d{0,3}))?\s*(,|$)/i", 
	                   $http_accept_language, $hits, PREG_SET_ORDER); 

	    $bestlang = $available_languages[0]; 
	    $bestqval = 0; 
	
	    foreach ($hits as $arr) { 

	        $langprefix = strtolower ($arr[1]); 
	        if (!empty($arr[3])) { 
	            $langrange = strtolower ($arr[3]); 
	            $language = $langprefix . "-" . $langrange; 
	        } 
	        else $language = $langprefix; 
	        $qvalue = 1.0; 
	        if (!empty($arr[5])) $qvalue = floatval($arr[5]); 

	        if (in_array($language,$available_languages) && ($qvalue > $bestqval)) { 
	            $bestlang = $language; 
	            $bestqval = $qvalue; 
	        } 

	        else if (in_array($langprefix,$available_languages) && (($qvalue*0.9) > $bestqval)) { 
	            $bestlang = $langprefix; 
	            $bestqval = $qvalue*0.9; 
	        } 
	    } 
	    return $bestlang; 
	} 
}

?>
