<?php /*windu.org core*/
class systemStatus
{
	public static function writeTodayStatus($url) {
		$systemStatusDB = new systemstatusDB();
		if(!$systemStatusDB->haveTodayStatus()){
			$actualStatus = self::generate($url);
			$systemStatusDB->addStatus($actualStatus);
			
			if (config::get('sitemap')) {
				$sitemap = seo::sitemap();
				baseFile::saveFile(__SITE_PATH.'/sitemap.xml', $sitemap);
			}			
		}
	}
	public static function generate($url) {
		//database status
		$status['images'] = baseDB::getRecordsCount('imagesDB');
		$status['files'] = baseDB::getRecordsCount('filesDB');
		$status['sendedEmails'] = baseDB::getRecordsCount('mailDB');
		$status['contacts'] = baseDB::getRecordsCount('contactDB');
		$status['pages'] = baseDB::getRecordsCount('pagesDB');
		$status['comments'] = baseDB::getRecordsCount('commentsDB');
		$status['rates'] = baseDB::getRecordsCount('ratesDB');
		$status['versions'] = baseDB::getRecordsCount('pagesbackupsDB');

		$logDB = new logDB();
		$status['logErrors'] = $logDB->fetchCount("bucket=".logDB::BUCKET_ERROR);
		$status['log404'] = $logDB->fetchCount("bucket=".logDB::BUCKET_404);
		
		
		$status['users'] = baseDB::getRecordsCount('usersDB');
		
		//system status
		$status['revision'] = config::get('revision');
		$status['size'] = self::pageSize();
		
		//external status
		$status['googlePr'] = seo::googlePr($url);
		$status['googlePageSpeed'] = self::googlePageSpeed($url);
		
		$status['alexaCountryRank'] = seo::alexaCountryRank($url);
		$status['alexaGlobalRank'] = seo::alexaGlobalRank($url);
		$status['alexaLink'] = seo::alexaLink($url);
		$status['alexaSpeed'] = seo::alexaLink($url);
		
		return $status;
	}
	
	public static function pageSize($expire = 7200){
		if (!cache::isCached(__SITE_PATH,$expire)){
			cache::write(__SITE_PATH,round(baseFile::getSize(__SITE_PATH)/1048576,2),'disSize');
		}
		return cache::read(__SITE_PATH);		
	}
	public static function googlePageSpeed($url) {
        $googleUrl  = 'http://developers.google.com/_apps/pagespeed/run_pagespeed?url='.$url.'&format=json';
        $str  = externalContent::get($googleUrl);

        $data = json_decode($str);
        return intval($data->results->score);
	}
}

?>
