<?php
 require_once './app/core/pluginManager.class.php';
 require_once './app/core/debugger.class.php';
 
 if (!file_exists(__SITE_PATH.'/cache/system/sitepath.tmp')) {
 	file_put_contents(__SITE_PATH.'/cache/system/sitepath.tmp', __SITE_PATH);
 }else{
 	$sitePathFromCache = file_get_contents(__SITE_PATH.'/cache/system/sitepath.tmp');
 	if ($sitePathFromCache!=__SITE_PATH) {
 		$filesInCacheSystem = scandir(__SITE_PATH.'/cache/system/');
 		foreach ($filesInCacheSystem as $fileSystemCache){
 			if ($fileSystemCache!='.' and $fileSystemCache!='..') {
 				unlink(__SITE_PATH.'/cache/system/'.$fileSystemCache);
 			}
 		}
 		file_put_contents(__SITE_PATH.'/cache/system/sitepath.tmp', __SITE_PATH);
 	}
 }
 
 function prepereAutoloadFilesList() {
 	$cacheFile = __SITE_PATH.'/cache/system/classlist.tmp';
 	if (file_exists($cacheFile)) {
 		$filesList = unserialize(file_get_contents($cacheFile));
 	}else{
		$catalogs[] = '/app/core/';
		$catalogs[] = '/app/model/';
		$catalogs[] = '/app/controller/';
		
		$plugins = pluginManager::getList();
		
		foreach ($plugins as $plugin) {
		 	$file = PLUGIN_PATH.'/'.$plugin;
		 	if (is_dir('./'.$file.'/')){$catalogs[] =  '/'.$file.'/';}
		 	if (is_dir('./'.$file.'/controller'))$catalogs[] = '/'.$file.'/controller/';
		 	if (is_dir('./'.$file.'/controller/do'))$catalogs[] = '/'.$file.'/controller/do/';
		 	if (is_dir('./'.$file.'/controller/ajax'))$catalogs[] = '/'.$file.'/controller/ajax/';
		 	if (is_dir('./'.$file.'/model'))$catalogs[] =  '/'.$file.'/model/';
		 	if (is_dir('./'.$file.'/addons'))$catalogs[] =  '/'.$file.'/addons/';
		}
		
		$filesList = array();
		foreach ($catalogs as $catalog){
			$catalogFiles = scandir(__SITE_PATH.$catalog);
			foreach ($catalogFiles as $catalogFile){
				$filesCatalogList[$catalogFile] = $catalog.$catalogFile;
			}
			$filesList = array_merge($filesCatalogList,$filesList);
		}
		if(!is_dir(__SITE_PATH.'/cache/')) mkdir(__SITE_PATH.'/cache/', 0755);		
		$systemCacheDir = __SITE_PATH.'/cache/system/';
		if(!is_dir($systemCacheDir)) mkdir($systemCacheDir, 0755);
		
		file_put_contents($cacheFile, serialize($filesList));
 	}
	return $filesList;
 }
 $filesAutoload = prepereAutoloadFilesList();

 /*** auto load model classes ***/
 spl_autoload_register('autoload');
 function autoload($class_name)
 {
    $filename = $class_name . '.class.php';
	global $filesAutoload;
	if ($filesAutoload[$filename]!='')	require_once (__SITE_PATH.$filesAutoload[$filename]);
}

 //Dir on serwer
 define('SUBDIR', rtrim($_SERVER['PHP_SELF'],'front.php'));
 define('HOME', __BASE.SUBDIR); 
 
 pluginManager::loadMainConfigs(); //load config.php files from plugins
 
 //Call controller
 $request = new requestHttp($_SERVER, $_GET, $_POST);

 $renderedResponse = router::instance()->callController($request);
 
?>