<?php /*windu.org model*/
class themesDB
{
	public static $baseTpl = array(
	'tpl_main/error404.tpl',
	'tpl_main/main.tpl',
	'tpl_mail/register_mail.tpl',
	'tpl_mail/password_recovery_mail.tpl',
	'tpl_views/simple_page.tpl',
	'tpl_views/main_page.tpl',
	'js/main.js',
	'css/main.css');
	
	public static $baseFolders = array(
	'css',
	'img',
	'js',
	'tpl_common',
	'tpl_mail',
	'tpl_main',
	'tpl_views');

	public static $baseViewsFolders = array(
	'tpl_views');
	
	public static $basicTpl = 'simple_page.tpl';
	
	function __construct($templateName = null)
	{
		$this->tplName = $templateName;
		if($this->tplName == null)
		{
			$configDB = new configDB();
			$themeConfig = $configDB->getByName('template');
			$this->tplName = $themeConfig->name;
		}	
		$this->templatePath = TEMPLATES_PATH.$this->tplName.'/';
	}	
	//Creating template with default files and catalogs
	public static function create($templateName){
		if (DB_READ_ONLY_MODE==1) return true;	
		
		$templateName = generator::cleanFileName($templateName);
		if(!is_dir(TEMPLATES_PATH.$templateName)){
			baseFile::createDir(TEMPLATES_PATH.$templateName);
			foreach (self::$baseFolders as $folder){
				baseFile::createDir(TEMPLATES_PATH.$templateName.'/'.$folder);
				echo TEMPLATES_PATH.$templateName.'/'.$folder;
			}
			foreach (self::$baseTpl as $tpl){
				baseFile::saveFile(TEMPLATES_PATH.$templateName.'/'.$tpl, '');
			}			
			return true;
		}
		return false;
	}
	//Add tpl file
	public function add($fileName) {
		if (DB_READ_ONLY_MODE==1) return true;	
		$fileName = generator::cleanFileName($fileName);
		return baseFile::saveFile($this->templatePath.$fileName.'.tpl', '');
	}
	public function delete($fileName) {
		if (DB_READ_ONLY_MODE==1) return true;	
		return baseFile::delete($this->templatePath.$fileName);
	}
	public function deleteTemplate() {
		if (DB_READ_ONLY_MODE==1) return true;	
		return baseFile::delete($this->templatePath);
	}
	public function save($fileName, $data) {
		if (DB_READ_ONLY_MODE==1) return true;	
		return baseFile::saveFile($this->templatePath.$fileName, $data);
	}
	public function read($fileName) {
		return baseFile::readFile($this->templatePath.$fileName);
	}	
	public function rename($newname) {
		if (DB_READ_ONLY_MODE==1) return true;	
		$newname = generator::cleanFileName($newname);
		$namePom = str_replace(TEMPLATES_PATH, '', $this->templatePath);
		if(is_dir(TEMPLATES_PATH.$newname.'/')){return false;}
		if(config::get('template') == $this->tplName){
			config::set('template', $newname);
		}
		return baseFile::rename($this->templatePath, TEMPLATES_PATH.$newname.'/');
	}	
	public static function getViewsArray($themeName = null){
		if($themeName == null)
		{
			$configDB = new configDB();
			$themeConfig = $configDB->getByName('template');
			$themeName = $themeConfig->value;
		}
				
		$views = baseFile::getFilesList(TEMPLATES_PATH.$themeName.'/','tpl',true);
		$viewsArray[self::$basicTpl]=rtrim(self::$basicTpl,'.tpl');
		foreach(self::$baseViewsFolders as $folder){
			foreach($views[$folder]->subdir as $view){
				$viewsArray[$view->name]=rtrim($view->name,'.tpl');
			}			
		}
		return $viewsArray;
	}
	//Return array of resources inside type folder
	public static function getAllResources($type){
		$template = config::get('template');
		$folder = TEMPLATES_PATH.$template.'/'.$type.'/';
		$files = baseFile::getFilesList($folder,$type);	
		$finalArr = array();
		foreach ($files as $file){
			if (preg_match('/main.css/', $file->path) or preg_match('/main.js/', $file->path)) {
				$main = $file->path;
			}else{
				$finalArr[] = $file->path;
			}
		}
		
		if ($main!=null) {
			$finalArr[] = $main;
		}
		

		return $finalArr;
	}
}
?>
