<?php /*windu.org model*/
class usersDB extends traceDB
{
	public function add($data,$active = 0)
	{
		$pass = $data['password'];
		$data['active'] = $active;
		if ($data['username']==null) {
			$username = explode('@',$data['email']);
			$data['username'] = $username[0];
		}
		if ($pass==null){
			$pass = generator::randomCode(8,2);
			$data['password'] = $pass;
		}
		$returnData = $data;
		$data['password'] = $this->saltPassword($pass);
		$this->insert($data);
		return $returnData;
	}
	public function updateRow($data,$where) {
		if($data['password']!=null){
			$data['password'] = $this->saltPassword($data['password']);
		}
		parent::updateRow($data, $where);
	}
	//Sprawdza czy user jest zalogowany
	public function authCheck($className,$type){
		$sessionDB = new sessionDB();
		$usersDB = new usersDB();
		$emailKey = cookie::readCookie('login');
		$passKey = cookie::readCookie('pass');

		$email = $sessionDB->get($emailKey);
		$password = $sessionDB->get($passKey);

		if($this->checkUserLogin($email, $password, $type)){
			$user = $usersDB->fetchRow("email = '{$email}'");
			if ($this->promissionCheck($user,$className)){
				return true;
			}
		}

		return false;
	}
	//Sprawdza uprawnienia zalogowanego usera
	public static function permissionCheck($className) {
		$userDB = new usersDB();
		$user = $userDB->getLoggedIn();
		if ($userDB->promissionCheck($user,$className)){
			return true;
		}
		return false;
	}
	//Zwraca zalgoowanego usera
	public function getLoggedIn($type = null) {
		$sessionDB = new sessionDB();
		$emailKey = cookie::readCookie('login');
		$email = $sessionDB->get($emailKey);
		$user = $this->fetchRow("email='{$email}'");
		
		if ($type!=null) {
			$type = 'is'.$type;
			if (!$this->$type($user)){
				return null;
			}			
		}
		return $user;
	}
	//sprawdzanie uprawnien do danego kontrolera
	public function promissionCheck($user,$className) {
		$usertypesDB = new usertypesDB();
		if($usertypesDB->havePromission($user,$className)){
			return true;
		}
		return false;
	}

	//Sprawdza czy user podal porpawne haslo i nazwe usera
	public function checkUserLogin($email,$password,$type = null)
	{
		if (empty($email) or empty($password)) {
			return false;
		}

		$bindValues = array(':email' => $email, ':password' => $password, ':active' => 1);
		$user = $this->fetchRow("email=:email and password=:password and active=:active",null,'*',$bindValues);
		
		if ($type!=null) {
			$type = 'is'.$type;
			if ($user!=null and $this->$type($user)){
				return true;
			}			
		}else{
			if ($user!=null){
				return true;
			}			
		}
		
		return false;
	}
	public function isPageUser($user) {
		$usertypesDB = new usertypesDB();
		if ($usertypesDB->get($user->type, 'bucket')==usertypesDB::BUCKET_PAGE) {
			return TRUE;
		}
		return false;
	}	 
	public function isAdminUser($user) {
		$usertypesDB = new usertypesDB();
		if ($usertypesDB->get($user->type, 'bucket')==usertypesDB::BUCKET_SYSTEM) {
			return TRUE;
		}
		return false;
	}
	public function login($email,$password,$expire = 0) {
		$sessionDB = new sessionDB();
		if($expire == 0){
			$sessionExpire = 86400;
		} else {
			$sessionExpire = $expire;
		}
		$emailKey = $sessionDB->set($email, $sessionExpire);
		$passKey = $sessionDB->set($this->saltPassword($password), $sessionExpire);

		cookie::setCookie('login',$emailKey,$expire);
		cookie::setCookie('pass',$passKey,$expire);
	}
	
	////////////////////User Mode section////////////////////
	public function toggleDeveloperMode(){
		$user = $this->getLoggedIn();
		if (cookie::readCookie('developerMode')==$user->email) {
			cookie::removeCookie('developerMode');
		}else{
			cookie::removeCookie('simpleUserMode');
			cookie::setCookie('developerMode',$user->email,0);
		}
	}
	public function isDeveloper() {
		$user = $this->getLoggedIn();
		if (cookie::readCookie('developerMode')==$user->email) {
			return true;
		}
		return false;
	}
	public function toggleSimpleUserMode(){
		$user = $this->getLoggedIn();
		if (cookie::readCookie('simpleUserMode')==$user->email) {
			cookie::removeCookie('simpleUserMode');
		}else{
			cookie::removeCookie('developerMode');
			cookie::setCookie('simpleUserMode',$user->email,0);
		}
	}	
	public function isSimpleUser() {
		$user = $this->getLoggedIn();
		if (cookie::readCookie('simpleUserMode')==$user->email) {
			return true;
		}
		return false;
	}	
	//////////////////////////////////////////////////////////
	
	
	public function logout(){
		cookie::removeCookie('login');
		cookie::removeCookie('pass');
	}
	public function activate($id) {
		$this->set($id, 'active', 1);
	}
	public function deActivate($id) {
		$this->set($id, 'active', 0);
	}
	public function setRandomPassword($id) {
		$newPassword = generator::randomCode(8,2);
		$this->set($id, 'password', $this->saltPassword($newPassword));
		return $newPassword;
	}	
	
	public function activateByEmail($email) {
		$userId = $this->fetchRow("email = '{$email}'")->id;
		$this->activate($userId);
	}
	public function deActivateByEmail($email) {
		$userId = $this->fetchRow("email = '{$email}'")->id;
		$this->deActivate($userId);
	}	
	//TODO - kasowanie usera dorobic powiazania wszytskie, na przyklad co
	public function deleteUser($id) {
		image::deleteImageByBucket('user-'.$id);
		$this->deleteRows("id = '{$id}' and 'superAdministrator' !=1");
	}
	public function getByBucket($bucketId,$where = null, $order = null, $what = '*', $limit = null, $groupby = null, $bindValues = array() ){
		$userTypesDB = new usertypesDB();
		$userTypes = $userTypesDB->getByBucket($bucketId,null,true,true);
		if ($userTypes!=null) {
			if ($where!=null) {
				$where=' AND '.$where;
			}
			$users = $this->fetchAll("type in({$userTypes})$where",$order,$what,$limit,$groupby,$bindValues);
		}
		return $users;
	}
	public function getCommentsCount($userId) {
		$commentsDB = new commentsDB();
		$count = $commentsDB->fetchCount("userId = {$userId}");
		return $count;
	}
	public function getRatesCount($userId) {
		$ratesDB = new ratesDB();
		$count = $ratesDB->fetchCount("userId = {$userId}");
		return $count;
	}	
	public function saltPassword($password) {
		$passwordPieces = array_reverse(str_split($password));
		$saltPieces = str_split(config::get('salt'));
		
		$counter = 0;
		foreach ($passwordPieces as $piece) {
			$finalPassword.=$piece.$saltPieces[$counter];
			$counter = $counter+1;
			if ($counter>=32)$counter = 0;
		}
		
		return sha1(sha1(md5(sha1(md5($finalPassword)))));
	}

}
?>