<?php /*windu.org admin controller*/

Class adminContentController Extends adminMainConfigController{
	public function __construct($request){
		$usersDB = new usersDB();
		parent::__construct($request);

		$pagesDB = new pagesDB();
		$imagesDB = new imagesDB();
		$langs = $pagesDB->fetchAll("type=".pagesDB::TYPE_LANG_CATALOG." and status !=".pagesDB::STATUS_DELETE,'id ASC','*');
			
		$formLang = new form('addLang','addLangSuccess',$_POST,'POST','form-horizontal');
		$formLang->add('name', 'input-text',lang::read('admin.content.controller.newlangname'));
		$formLang->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$formLang->addButton('submit',lang::read('form.button.title.add'),'btn btn-primary', null, null, 'icon-plus icon-white');	
		$formLang->setHandler($this);
		$formLang->handle();
		
		$configDB = new configDB();
		$config = $configDB->getByGroup(configDB::CONFIG_BUCKET_CONTENT);	
		$this->smarty->assign('configList',$config);
		
		$images = $imagesDB->getByBucket($this->request->getVariable('id'));
		$this->smarty->assign('images',$images);		
		
		$this->smarty->assign('languagePath',LANGUAGES_PATH);
		$this->smarty->assign('config',$langs);
		$this->smarty->assign('langs',$langs);
		$this->smarty->assign('pagesDB',$pagesDB);	
		$this->smarty->assign('pagesBackupsDB',new pagesbackupsDB());	
		$this->smarty->assign('imagesDB',$imagesDB);	
		$this->smarty->assign('formLang',$formLang);	
		$this->smarty->assign('id',$this->request->getVariable('id'));
	
	}
	public function index()
	{	
		$this->pageDisplay('content');
	}

	public function add() {
		$pagesDB = new pagesDB();
		$page = $pagesDB->fetchRow("id={$this->request->getVariable('id')}");
		
		$form = new form('add','addSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'));
		$form->add('type', 'select',lang::read('admin.content.controller.elementtype'), cookie::readCookie('lastContentAdd'), array("option"=>$pagesDB->getTypes()));

		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$form->addButton('submit',lang::read('form.button.title.add'),'btn btn-primary',null,null,'icon-plus icon-white');
		$form->setHandler($this);
		$form->handle();
		$this->smarty->assign('contentType','form'); 
		$this->smarty->assign('form',$form);	
		$this->pageDisplay('content');
	}
	public function addSuccess($data) {
		$pagesDB = new pagesDB();
		$data = array_merge($data,array('parentId'=>$this->request->getVariable('id')));
		$page = $pagesDB->insert($data);
		cookie::setCookie('lastContentAdd',$data['type']);
		router::reload();
	}		
	public function addLangSuccess($data) {
		$pagesDB = new pagesDB();
		$pagesDB->addLang($data);
		router::reload();
	}		
	public function edit() {
		
		$pagesbackupsDB = new pagesbackupsDB();
		$restorePages = null;
		if (is_numeric($this->request->getVariable('id'))) {
			if ($pagesbackupsDB->hasRestorePoint($this->request->getVariable('id'))) {	
				$restorePages = $pagesbackupsDB->getBackupes("pageId = {$this->request->getVariable('id')}");
			}
		}
		$pagesDB = new pagesDB();
		$page = $pagesDB->fetchRow("id={$this->request->getVariable('id')}");
		
		$page->content = str_replace('{{$HOME}}',HOME,$page->content);
		
		$form = new form('edit','editSuccess',$_POST,'POST','form-horizontal no-margin',null,false,HOME.'admin/do/content/editAjaxSuccess/'.$this->request->getVariable('id').'/');
 
		$form->add('HTML','
		  <ul class="nav nav-tabs" id="tabContent">
		  	<li><a href="#tabContent1" style="margin-left:5px;"><i class="icon-book"></i>&nbsp; '.lang::read('admin.content.controller.content').'</a></li>
		    <li><a href="#tabContent2"><i class="icon-wrench"></i>&nbsp;'.lang::read('admin.content.controller.general').'</a></li>
		    <li><a href="#tabContent3"><i class="icon-search"></i>&nbsp;'.lang::read('admin.content.controller.seo').'</a></li>');
		if (count($restorePages)>0){$form->add('HTML','<li><a href="#tabContent5"><i class="icon-tasks"></i>&nbsp;'.lang::read('admin.content.controller.ver').' ('.count($restorePages).')</a></li>');}
		$form->add('HTML','<li><a href="#tabContent4"><i class="icon-picture"></i>&nbsp;'.lang::read('admin.content.controller.imageslider').'</a></li>');	
		$form->add('HTML','<li><a href="#tabContent6"><i class="icon-info-sign"></i>&nbsp;'.lang::read('admin.content.controller.info').'</a></li></ul>');		
		$form->add('HTML','<div class="tab-content">');
		$form->add('HTML','<div class="tab-pane" id="tabContent1">');	
		$form->add('content', 'textareaCKEditor','',$page->content,array('editorType'=>config::get('editorCKEType')));	
		$form->add('HTML','</div>');
		$form->add('HTML','<div class="tab-pane" id="tabContent2">');
		$form->add('name', 'input-text', lang::read('admin.content.controller.elementname'),$page->name);
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));		
		if ($page->type == pagesDB::TYPE_NEWS) {
			$form->add('date', 'inputDataPicker',lang::read('admin.content.controller.date'),$page->date,array("tooltip" => lang::read('admin.content.controller.datedescription')));
		}
		
		$imagesDB = new imagesDB();
		
		//image/////
		$mainImage = $imagesDB->getFirstByBucket('main-'.$this->request->getVariable('id'));
		if(is_object($mainImage)){
			$form->add('HTML',"
			<div class='control-group'>
				<label class='control-label'>
					<a href='".HOME."admin/do/content/deleteMainImage/main-{$this->request->getVariable('id')}/'><i class='icon-remove-sign icon-red'>&nbsp;</i></a>
				</label>
				<div class='controls'>
					<img src='".HOME."image/{$mainImage->ekey}/200/150/fit/'>
				</div>
			</div>");
		}

		$form->add('image', 'input-file',lang::read('admin.content.controller.image'),null,array("tooltip" => lang::read('admin.content.controller.imagedescription')));	
		
		//icon///////
		$mainIcon = $imagesDB->getFirstByBucket('icon-'.$this->request->getVariable('id'));
		if(is_object($mainIcon)){
			$form->add('HTML',"
			<div class='control-group'>
				<label class='control-label'>
					<a href='".HOME."admin/do/content/deleteMainImage/icon-{$this->request->getVariable('id')}/'><i class='icon-remove-sign icon-red'>&nbsp;</i></a>
				</label>
				<div class='controls'>
					<img src='".HOME."image/{$mainIcon->ekey}/200/150/fit/'>
				</div>
			</div>");
		}		
		$form->add('icon', 'input-file',lang::read('admin.content.controller.icon'),null,array("tooltip" => lang::read('admin.content.controller.icondescription')));	
		
		$form->add('menuCssClass', 'input-text', lang::read('admin.content.controller.menucssclass'),$page->menuCssClass);
		
		$form->add('tpl', 'select','Template',$page->tpl,array('option' => themesDB::getViewsArray(),"tooltip" => lang::read('admin.content.controller.chosentemplate')));
		if($page->type >= 10){
			$form->add('defaultTpl','select',lang::read('admin.content.controller.defaulttemplate'),$page->defaultTpl,array('option' => themesDB::getViewsArray(),"tooltip" => lang::read('admin.content.controller.chosendefaulttemplate')));
		}
		
		if(!$pagesDB->hasChild($page->id) and $page->type != pagesDB::TYPE_NEWS){
			$form->add('type', 'select',lang::read('admin.content.controller.elementtype'),$page->type, array("option"=>$pagesDB->getTypes(),"tooltip" => lang::read('admin.content.controller.typeconvert')));
		}
		$form->add('HTML','</div>');
		$form->add('HTML','<div class="tab-pane" id="tabContent3">');	
		$form->add('urlKey', 'input-text',lang::read('admin.content.controller.linkname'),$page->urlKey);
		$form->addRule('urlKey', 'unique', array('table'=>$pagesDB,'where'=>"id!={$this->request->getVariable('id')}"),lang::read('admin.content.controller.adresstaken'));
		$form->add('title', 'input-text','Title',$page->title,array("tooltip" => lang::read('admin.content.controller.sitetitle')));
		$form->add('description', 'input-text','Description',$page->description,array("class" => "span8","tooltip" => lang::read('admin.content.controller.descriptioninsection')));
		$form->add('keywords', 'input-text','Keywords',$page->keywords,array("class" => "span8","tooltip" => lang::read('admin.content.controller.keywords')));
		
		$form->add('priority', 'input-text','Priority (sitemap)',$page->priority,array("class" => "span8","tooltip" => lang::read('admin.content.controller.priority')));	
		$form->add('tags', 'input-text','Tagi',$page->tags,array("class" => "span8","tooltip" => lang::read('admin.content.controller.sitetags')));	
		
		
		$form->add('HTML','</div>');
		$form->add('HTML','<div class="tab-pane" id="tabContent4">');
		//slider-images/////
		$sliderImages = $imagesDB->getByBucket('slider-'.$this->request->getVariable('id'));
		if(is_array($sliderImages)){
			foreach ($sliderImages as $image) {
				$form->add('HTML',"
				<div class='control-group'>
					<label class='control-label'>
						<a href='".HOME."admin/do/content/deleteImage/{$image->id}/'><i class='icon-remove-sign icon-red'>&nbsp;</i></a>
					</label>
					<div class='controls'>
						<img src='".HOME."image/{$image->ekey}/300/100/smart/'>
					</div>
				</div>");
			}
		}

		$form->add('sliderimage', 'input-file',lang::read('admin.content.controller.sliderimage'),null,array("tooltip" => lang::read('admin.content.controller.imagedescription')));			
		$form->add('HTML','</div>');
 
		
		
		if (count($restorePages)>0) {
			$form->add('HTML',"<div class='tab-pane' id='tabContent5'>
								<a href='".HOME."admin/do/content/compactPageVersions/{$page->id}/' class='btn pull-right margon-bottom margin-right'>".lang::read('admin.content.controller.compactversions')."</a><br><br><br>
						   		<table class='table table-striped tablesort'>
								");			
			$usersDB = new usersDB();
			foreach ($restorePages as $restorePoint) {
				$createUserName = $usersDB->get($restorePoint->createUser,'username');
				$form->add('HTML',"
				  	<tr>
						<td><i class='color-icons icons-document-zipper icon-margin'>&nbsp;</i>{$restorePoint->createTime}</td>
						<td>{$createUserName}</td>
						<td>
							<div class='buttons'>
								<a href='".HOME."admin/do/content/restorePage/{$restorePoint->id}/'><i class='icon-share icon-blue'>&nbsp;</i></a>
								<a href='".HOME."admin/do/content/deletePageVersion/{$restorePoint->id}/'><i class='icon-remove-sign icon-red'>&nbsp;</i></a>
							</div>
						</td>
					</tr>			
				");
			}
			$form->add('HTML','</tbody></table></div>');
		}
		
		$infoValues = array(
			'<i class="icon-globe icon-grey"></i>&nbsp; Link do strony' => '<a href="'.HOME.$page->urlKey.'" target="blank">'.HOME.$page->urlKey.'</a>',
			'<i class="icon-hdd icon-grey"></i>&nbsp; Numer ID' => $page->id,
			'<i class="icon-eye-open icon-grey"></i>&nbsp; Liczba wyświetleń' => $page->views,
			'<i class="icon-thumbs-up icon-grey"></i>&nbsp; Ocena' => $page->rate,
			'<i class="icon-calendar icon-grey"></i>&nbsp; Data utworzenia' => $page->createTime,
			'<i class="icon-calendar icon-grey"></i>&nbsp; Data ostatniej aktualizacji' => $page->updateTime,
			'<i class="icon-map-marker icon-grey"></i>&nbsp; IP twórcy' => $page->createIP,
			'<i class="icon-map-marker icon-grey"></i>&nbsp; IP ostatniego edytora' => $page->updateIp,
			'<i class="icon-share icon-grey"></i>&nbsp; Kod wstawiania treści' => '{{eval var=$pagesDB->get('.$page->id.',content)}}'
		);
		
		$form->add('HTML','<div class="tab-pane" id="tabContent6"><table class="table table-striped tablesort">');
		foreach ($infoValues as $key => $info){
			$form->add('HTML',"<tr><td>{$key}</td><td>{$info}</td></tr>");		
		}	
		$form->add('HTML','</table></div>');
		
		
		$form->add('HTML','</div>');
		$ajaxUrl = HOME.'admin/content/editSuccess/'.$this->request->getVariable('id').'/';

		$form->addButton('submit',lang::read('form.button.title.save'),'btn btn-primary', null, 'data-loading-text="<i class=\'icon-refresh icon-white icon-button\'></i>'.lang::read('form.button.title.save').'"', 'icon-hdd icon-white');
		$form->addButton('images',lang::read('form.button.title.images'),"btn btn-margin-left","#modal",'data-toggle="modal" data-target="#imagesModal"', 'icon-picture');
		$form->addButton('files',lang::read('form.button.title.files'),"btn btn-margin-left","#modal",'data-toggle="modal" data-target="#filesModal"', 'icon-list-alt');
		$form->addButton('widgets',lang::read('form.button.title.widgets'),"btn btn-margin-left","#modal",'data-toggle="modal" data-target="#widgetsModal"', 'icon-bullhorn');
		$form->addButton('reload',"&nbsp","btn btn-margin-left",HOME.'admin/do/reload/','style="padding-left:12px; padding-right:2px;"', 'icon-refresh');
				
		$form->setHandler($this);
		$form->handle();
		
		$this->smarty->assign('contentType','edit');  
		$this->smarty->assign('form',$form);
		
		$this->pageDisplay('content');
	}
	public function editSuccess($data) {
		$pagesDB = new pagesDB();
 
		if ($_FILES['image']['error']==0) {
			image::deleteImageByBucket('main-'.$this->request->getVariable('id'));
			image::saveIncomingImage($_FILES['image'],'main-'.$this->request->getVariable('id'));
			$data['hasImage'] = 1;
		}
		if ($_FILES['icon']['error']==0) {
			image::deleteImageByBucket('icon-'.$this->request->getVariable('id'));
			image::saveIncomingImage($_FILES['icon'],'icon-'.$this->request->getVariable('id'));
			$data['hasIcon'] = 1;
		}	
		if ($_FILES['sliderimage']['error']==0) {
			image::saveIncomingImage($_FILES['sliderimage'],'slider-'.$this->request->getVariable('id'));
		}			
		$page = $pagesDB->updatePage($data,"id={$this->request->getVariable('id')}");	
		router::reload();
	}

	public function editUrl() {
		$pagesDB = new pagesDB();
		$page = $pagesDB->fetchRow("id={$this->request->getVariable('id')}");
		
		$form = new form('edit','editUrlSuccess',$_POST,'POST','form-horizontal');
		
		$form->add('content', 'input-text',lang::read('admin.content.controller.url'),$page->content,array('editorType'=>'basic'));
		$form->addRule('content', 'required', null,lang::read('admin.content.controller.giveelementname'));	
		$form->addRule('content', 'url', null,lang::read('admin.content.controller.givecorrecturl'));
		$form->add('name', 'input-text', lang::read('admin.content.controller.elementname'),$page->name);
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));
		//icon///////
		$imagesDB = new imagesDB();
		$mainIcon = $imagesDB->getFirstByBucket('icon-'.$this->request->getVariable('id'));
		if(is_object($mainIcon)){
			$form->add('HTML',"
			<div class='control-group'>
				<label class='control-label'>
					<a href='".HOME."admin/do/content/deleteMainImage/icon-{$this->request->getVariable('id')}/'><i class='icon-remove-sign icon-red'>&nbsp;</i></a>
				</label>
				<div class='controls'>
					<img src='".HOME."image/{$mainIcon->ekey}/200/150/fit/'>
				</div>
			</div>");
		}		
		$form->add('icon', 'input-file',lang::read('admin.content.controller.icon'),null,array("tooltip" => lang::read('admin.content.controller.icondescription')));	
				
					
		$form->setHandler($this);
		$form->handle();
		
		$this->smarty->assign('contentType','form');  
		$this->smarty->assign('form',$form);		
		$this->pageDisplay('content');
	}
	public function editUrlSuccess($data) {
		$pagesDB = new pagesDB();
		$page = $pagesDB->updatePage($data,"id={$this->request->getVariable('id')}");
		if ($_FILES['icon']['error']==0) {
			image::deleteImageByBucket('icon-'.$this->request->getVariable('id'));
			image::saveIncomingImage($_FILES['icon'],'icon-'.$this->request->getVariable('id'));
		}			
		router::reload();
	}
	public function editLang() {
		$pagesDB = new pagesDB();
		$lang = $pagesDB->fetchRow();
		$formLang = new form('editLang','editLangSuccess',$_POST,'POST','form-horizontal no-margin');
		$formLang->setMenuFloating();
		$formLang->add('content', 'textareaCodeMirrorEditor',null,file_get_contents(LANGUAGES_PATH.strtolower($this->request->getVariable('id')).'/'.$this->request->getVariable('secoundId')));
		
		$formLang->addButton('submit',lang::read('form.button.title.save'),'btn btn-primary', null, null, 'icon-hdd icon-white');
		
		$formLang->addButton('cancel',lang::read('form.button.title.cancel'),'btn btn-margin-left',HOME.'admin/content/',null,'icon-ban-circle');
		$formLang->setHandler($this);
		$formLang->handle();	
		
		$this->smarty->assign('formLang',$formLang);	
		$this->pageDisplay('content');
	}	
	public function editLangSuccess($data) {
		$data['content']=str_replace("'", "&apos;", $data['content']);
		baseFile::saveFile(LANGUAGES_PATH.strtolower($this->request->getVariable('id')).'/'.$this->request->getVariable('secoundId'), $data['content']);
		cache::clearBucket('lang');
		router::reload();
	}	
	public function editImage() {
		$imagesDB = new imagesDB();
		$image = $imagesDB->fetchRow("id={$this->request->getVariable('id')}");
		$form = new form('edit','editImageSuccess',$_POST,'POST','form-horizontal');

		$form->add('name', 'input-text',lang::read('admin.content.controller.name'),$image->name);
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));		
		$form->add('description', 'textareaCKEditor','',$image->description,array('editorType'=>'minimal_source'));
		
		$form->setHandler($this);
		$form->handle(); 
		 
		$this->smarty->assign('contentType','image');  
		$this->smarty->assign('form',$form);
		$this->smarty->assign('image',$image);		
		$this->pageDisplay('content');
	}	
	public function editImageSuccess($data) {
		$imagesDB = new imagesDB();
		$image = $imagesDB->updateRow($data,"id={$this->request->getVariable('id')}");
		router::reload();
	}	

	public function gallery() {
		$this->smarty->assign('contentType','gallery'); 
		$this->pageDisplay('content');
	}	
	public function news() {
		$pagesDB = new pagesDB();
		$news = $pagesDB->fetchAll("parentId = {$this->request->getVariable('id')} and status = ".pagesDB::STATUS_ACTIVE,'position ASC');
		
		$form = new form('addnews','addNewsSuccess',$_POST,'POST','form-horizontal no-margin');
		
		$form->add('content', 'textareaCKEditor','',null,array('editorType'=>'basic'));
		$form->add('name', 'input-text', lang::read('admin.content.controller.newstitle'));
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->add('image', 'input-file',lang::read('admin.content.controller.image'),null,array("tooltip" => lang::read('admin.content.controller.imagedescription')));	
		$form->add('tags', 'input-text',lang::read('admin.content.controller.tags'),null,array("class" => "span8","tooltip" => lang::read('admin.content.controller.sitetags')));		
		$form->add('date', 'inputDataPicker',lang::read('admin.content.controller.date'),strtotime('now'),array("tooltip" => lang::read('admin.content.controller.datedescription')));
		
		$form->add('tpl', 'select',lang::read('admin.content.controller.template'),$pagesDB->get($this->request->getVariable('id'), 'defaultTpl'),array('option' => themesDB::getViewsArray(),"tooltip" => lang::read('admin.content.controller.chosentemplate')));

		$form->setHandler($this);
		$form->handle();

		$form->addButton('submit',lang::read('admin.content.controller.addnews'),'btn btn-primary', null, null, 'icon-plus icon-white');
		
		$this->smarty->assign('form',$form);
		
		$this->smarty->assign('newsAll',$news); 
		$this->smarty->assign('contentType','news'); 
		$this->pageDisplay('content');
	}
		
	public function addNewsSuccess($data) {
		$pagesDB = new pagesDB();
		$data = array_merge($data,array('parentId'=>$this->request->getVariable('id'),'type' => pagesDB::TYPE_NEWS));
		$pagesDB->insert($data);
		$news = $pagesDB->fetchRow("parentId = {$this->request->getVariable('id')}",'updateTime DESC'); 
		
		if ($_FILES['image']['error']==0){
			image::deleteImageByBucket('main-'.$news->id);
			image::saveIncomingImages('main-'.$news->id);
			$pagesDB->set($news->id, 'hasImage', 1);
		}
		
		router::reload();
	}	
	public function editConfig() {
		parent::editConfig();
		$this->pageDisplay('content');
	}
		
}
?>
