<?php /*windu.org admin controller*/
Class adminInstallController extends adminNoAuthController
{	
	private $extensionsRequired = array('curl','pdo_sqlite');
	function smartyGo()
	{
		parent::smartyGo();
		$this->smarty->template_dir = array(__SITE_PATH . '/app/plugins/admin/templates/');
	}
	public function __construct($request){
		if (config::get('install')!=0){
			router::redirect('admin');
			exit;
		}
		parent::__construct($request);
	}
	public function index()
	{	
		$this->smarty->assign('pagesDB',new pagesDB());	
		$this->smarty->assign('title','Select Language');	
		$this->pageDisplayHook('install.tpl','mainSimple.tpl');
	}
	public function setLanguage() {
		config::set('language-front', $this->request->getVariable('id'));
		config::set('language-admin', $this->request->getVariable('id'));
		
		$pagesDB = new pagesDB();
		$pagesDB->update('position','2', "parentId=0");
		$pagesDB->set($this->request->getVariable('id'),'position',1);
		
		router::redirect('admin-install-action',array("action" => "startInstallation"));
	}
	public function startInstallation()
	{	
		$this->smarty->assign('title',lang::read('admin.install.controller.welcome'));	
		$this->pageDisplayHook('install.tpl','mainSimple.tpl');
	}	
	public function checkServer() {
		foreach ($this->extensionsRequired as $extension) {
			if (!extension_loaded($extension)){
				$extensions[$extension] = 'Error';
			}else{
				$extensions[$extension] = 'OK';
			}
		}
		
		$chmodError = baseFile::checkCHMOD(__SITE_PATH);
		$chmodErrorCountFile = count($chmodError['file']);
		$chmodErrorCountDir = count($chmodError['dir']);
		
		$phpverpom = explode('.',phpversion());
		if ($phpverpom[0]>=5 and $phpverpom[1]>=2){$phpok = true;}else{$phpok = false;}

		$this->smarty->assign('chmodErrorCountFile',$chmodErrorCountFile);	
		$this->smarty->assign('chmodErrorCountDir',$chmodErrorCountDir);
		$this->smarty->assign('chmodError',$chmodError);
		$this->smarty->assign('extensions',$extensions);
		$this->smarty->assign('phpok',$phpok);
		
		$this->smarty->assign('checkserver',true);
		$this->smarty->assign('load','30');		
		$this->smarty->assign('title',lang::read('admin.install.controller.testing'));	
		$this->pageDisplayHook('install.tpl','mainSimple.tpl');		
	}

	public function setAdministrator() {
		
		$usersDB = new usersDB();
		
		$form = new form('adduser','setAdministratorSuccess',$_POST,'POST');
		$form->add('email', 'input-text',null,null,array("tooltip" => lang::read('admin.login.controller.autogener'),"class" => "input-medium","placeholder" => lang::read('admin.login.controller.username')));
		$form->addRule('email', 'required', null, lang::read('admin.users.controller.giveemail'));	
		$form->addRule('email', 'email', null, lang::read('admin.users.controller.givecorrectemail'));	
		$form->addRule('email', 'unique', array('table'=>$usersDB), lang::read('admin.users.controller.emailtaken'));

		$form->add('password', 'input-password',null,null,array("tooltip" => lang::read('admin.users.controller.autogener'),"class" => "input-medium","placeholder" => lang::read('admin.users.controller.password')));
		$form->addRule('password', 'string', array(6,50),lang::read('admin.users.controller.toshortpass'));	
		$form->addRule('password', 'same','passwordCompare',lang::read('admin.users.controller.diffpasswords'));
		$form->add('passwordCompare', 'input-password',null,null,array("class" => "input-medium","placeholder" => lang::read('admin.users.controller.repeatpassword')));

		$form->addButton('adduser',lang::read('admin.install.controller.next'),'btn btn-primary btn-large', null, null, 'icon-hdd icon-white');
		
		$form->setHandler($this);
		$form->handle();
		 
		$this->smarty->assign('form',$form);	
		$this->smarty->assign('load','50');	
		$this->smarty->assign('title',lang::read('admin.install.controller.setadmin'));	
		$this->pageDisplayHook('install.tpl','mainSimple.tpl');
	}	
	public function setAdministratorSuccess($data) {
		unset($data['passwordCompare']);
		$data['type'] = 9;
		$data['superAdministrator'] = 1;
		$usersDB = new usersDB();
		$user = $usersDB->add($data,1);
		
		$this->smarty->assign('data',$data);
		mail::send($data['email'], lang::read('admin.users.controller.youruserdata'), $this->smarty->fetch('mail/mailRegisterAdminUser.tpl'));
		
		if($usersDB->checkUserLogin($data['user'],$data['password'],'AdminUser')){
			$usersDB->login($data['user'], $data['password']);
			log::write($data['user'],logDB::BUCKET_LOGIN_SUCCESS);
			router::redirect('admin');
		}
		
		router::redirect('admin-install-action',array("action" => "setBasicConfig"));
	}	
	
	public function setBasicConfig() {
		$usersDB = new usersDB();
		
		$form = new form('setBasicConfig','setBasicConfigSuccess',$_POST,'POST');
		$form->add('pageName', 'input-text',null,null,array("class" => "input-medium","placeholder" => lang::read('admin.install.controller.pagename')));
		$form->addRule('pageName', 'required', null, lang::read('admin.content.controller.giveelementname'));	
		
		$form->addButton('addbasicconfig',lang::read('admin.install.controller.next'),'btn btn-primary btn-large', null, null, 'icon-hdd icon-white');
		
		$form->setHandler($this);
		$form->handle();
		 
		$this->smarty->assign('form',$form);	
		$this->smarty->assign('load','75');	
		$this->smarty->assign('title',lang::read('admin.install.controller.setbasicconfig'));	
		$this->pageDisplayHook('install.tpl','mainSimple.tpl');
	}	
	public function setBasicConfigSuccess($data) {
		config::set('pageName', $data['pageName']);
		$pagesDB = new pagesDB();
		$pagesDB->update('title', $data['pageName'], pagesDB::TYPE_LANG_CATALOG);
		
		router::redirect('admin-install-action',array("action" => "finish"));
	}		
	public function finish() {
		$configDB = new configDB();
		config::set('install', 1);
			
		$this->smarty->assign('load','100');	
		$this->smarty->assign('title',lang::read('admin.install.controller.installend'));	
		$this->smarty->assign('finish',true);	
		$this->pageDisplayHook('install.tpl','mainSimple.tpl');
	}
}
?>
