<?php /*windu.org admin controller*/
Class adminSystemController Extends adminMainConfigController{
	public function __construct($request){
		parent::__construct($request);

		$configDB = new configDB();
		$config = $configDB->getByGroup(configDB::CONFIG_BUCKET_SYSTEM);	
		$this->smarty->assign('configList',$config);		
		
		$logDB = new logDB();
		$this->smarty->assign('logDB',$logDB);
		
		$this->smarty->assign('dataFoldersPath',__SITE_PATH.'/');	
		
		$this->smarty->assign('backups',baseFile::getFilesList(__SITE_PATH . '/data/backups/','dir',false));	
		
		$notifyDB = new notifyDB();
		$notificationsClosed = $notifyDB->fetchAll('closed = 1','priority DESC,insertTime DESC');
		
		$this->smarty->assign('notificationsClosed',$notificationsClosed);
		
		$this->smarty->assign('pagesDB',new pagesDB());
		$this->smarty->assign('logDB',new logDB());
		$this->smarty->assign('imagesDB',new imagesDB());
		$this->smarty->assign('filesDB',new filesDB());
		
		$this->smarty->assign('pagesbackupsDB',new pagesbackupsDB());
		$this->smarty->assign('commentsDB',new commentsDB());
		$this->smarty->assign('ratesDB',new ratesDB());
		$this->smarty->assign('statisticDB',new statisticDB());
		
		$this->smarty->assign('usersDB',new usersDB());
		$this->smarty->assign('filesLogDB',new filesLogDB());
		$this->smarty->assign('mailDB',new mailDB());
		$this->smarty->assign('systemstatusDB',new systemstatusDB());
		
		

		
		if (!license::hasPro()) {
			$licenseForm = new form('license','licenseSuccess',$_POST,'POST','form-license');
			$licenseForm->add('key', 'input-text',null,null,array('class'=>'input-xlarge'));
			$licenseForm->addRule('key', 'required', null,lang::read('admin.system.controller.givelicensekey'));
			$licenseForm->addRule('key', 'numeric', null,lang::read('admin.system.controller.givelicensekey'));	
			$licenseForm->addRule('key', 'stringLength', array(32,32),lang::read('admin.system.controller.givelicensekey'));	
			$licenseForm->addButton('submit',lang::read('form.button.title.activate.license'),'btn btn-primary btn-large');
		
			$licenseForm->setHandler($this);
			$licenseForm->handle();

			$this->smarty->assign('licenseForm',$licenseForm);			
		}else{
			$this->smarty->assign('license',license::get());
		}
	}
	public function licenseSuccess($data) {
		if (license::activate($data['key'])) {
			router::redirect('admin-update',array('action' => 'afterLicence'));
		}else{
			router::reload('admin.message.wrong.licence.key','mn');
		}
		
	}
	public function index()
	{			
		$this->pageDisplay('system');
	}
	public function editConfig() {
		parent::editConfig();
		$this->pageDisplay('system');
	}		
}
?>
