<?php /*windu.org admin controller*/
Class adminToolsController Extends adminMainConfigController{
	public function __construct($request){
		parent::__construct($request);
		$configDB = new configDB();
		$config = $configDB->getByGroup(configDB::CONFIG_BUCKET_TOOLS);
		$this->smarty->assign('configList',$config);

		$this->smarty->assign('sitePath',__SITE_PATH);
		

		//Mailing
		$mailingTemplatesDB = new mailingtemplatesDB();
		$this->mailingTemplatesList = $mailingTemplatesDB->fetchAll();
		$this->smarty->assign('mailingTemplatesList',$this->mailingTemplatesList);

		$contactgroupsDB = new contactgroupsDB();
		$this->contactsGroups = $contactgroupsDB->fetchAll();
		$this->smarty->assign('contactsGroups',$this->contactsGroups);

		$mailingsDB = new mailingsDB();
		$this->mailingList = $mailingsDB->fetchAll(null,"status DESC, createTime ASC");
		$this->smarty->assign('mailingList',$this->mailingList);
		
		$this->smarty->assign('pagesDB',new pagesDB());
		$this->smarty->assign('logDB',new logDB());
		$this->smarty->assign('ratesDB',new ratesDB());
		$this->smarty->assign('commentsDB',new commentsDB());
		$this->smarty->assign('filesDB',new filesDB());
		$this->smarty->assign('filesLogDB',new filesLogDB());
		$this->smarty->assign('imagesDB',new imagesDB());
		$this->smarty->assign('mailingsDB',new mailingsDB());
		$this->smarty->assign('mailDB',new mailDB());
		$this->smarty->assign('contactDB',new contactDB());
		$this->smarty->assign('bannersareasDB',new bannersareasDB());
		$this->smarty->assign('bannersDB',new bannersDB());
		
		$systemStatusDB = new systemstatusDB();
		$systemStatusColumns = $systemStatusDB->fetchRow();
		unset($systemStatusColumns->id);
		unset($systemStatusColumns->date);

		$this->smarty->assign('systemStatusColumns',$systemStatusColumns);
		$this->smarty->assign('systemstatusDB',$systemStatusDB);
		
		
		
		$formAddFile = new form('addFile','addFileSuccess',$_POST,'POST','form-horizontal');
		$formAddFile->add('file', 'input-file',lang::read('admin.tools.controller.file'),null,array("tooltip" => lang::read('admin.tools.controller.filedescription')));	
		$formAddFile->setHandler($this);
		$formAddFile->handle();
		
		//SEO///////////////////////////
		$formSEO = new form('seo','seoSuccess',$_POST,'POST','form-horizontal');
		
		$formSEO->add('analiticsContent', 'input-text',lang::read('admin.common.seo.tpl.analcode'),config::get('analiticsCode'),array('class'=>'span11'));
		$formSEO->add('googleverifyContent', 'input-text',lang::read('admin.common.seo.tpl.verificationcode'),config::get('googleverifyCode'),array('class'=>'span11'));
		$formSEO->add('robotsContent', 'textarea',lang::read('admin.common.seo.tpl.robots'),baseFile::readFile(__SITE_PATH.'/robots.txt'),array('class'=>'span11 textarea-medium'));
				
		$formSEO->setHandler($this);
		$formSEO->handle();
		$this->smarty->assign('formSEO',$formSEO);
	
		
		$this->smarty->assign('formAddFile',$formAddFile);	
		
		$dbList = baseFile::getFilesList(__SITE_PATH . '/app/model/');
		foreach (explode(',',PLUGINS) as $plugin){
			if (is_dir(__SITE_PATH . '/app/plugins/'.$plugin.'/model/')) {
				$dbPluginList = baseFile::getFilesList(__SITE_PATH . '/app/plugins/'.$plugin.'/model/');
				if (is_array($dbPluginList)) {
					$dbList = array_merge($dbList,$dbPluginList);
				}
			}
		}
		$this->smarty->assign('dbList',$dbList);

	}
	public function index()
	{
		$this->pageDisplay('tools');
	}

	public function seoSuccess($data) {
		config::set('analiticsCode', $data['analiticsContent']);
		config::set('googleverifyCode', $data['googleverifyContent']);
		baseFile::saveFile(__SITE_PATH.'/robots.txt',$data['robotsContent']);
		router::reload();
	}
				
	public function addFileSuccess($data) {
		if ($_FILES['file']['error']==0) {
			file::saveIncomingFile($_FILES['file']);
		}
		router::reload();
	}
	
	//////////////////////////////////////////////////////////////////////
	//Mailing/////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	public function addMailingTemplate() {
		$form = new form('add','addMailingTemplateSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'));
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->add('content', 'textareaCKEditor','',null,array('editorType'=>'basic'));

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formMailing',$form);
		$this->smarty->assign('Dodaj szablon mailingu',$title);

		$this->pageDisplay('tools');
	}
	public function addMailingTemplateSuccess($data) {
		$mailingTemplatesDB = new mailingtemplatesDB();
		$mailingTemplatesDB->add($data);
		router::reload();
	}

	public function editMailingTemplate() {
		$mailingTemplatesDB = new mailingtemplatesDB();
		$template = $mailingTemplatesDB->fetchRow("id={$this->request->getVariable('id')}");

		$form = new form('add','editMailingTemplateSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'),$template->name);
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->add('content', 'textareaCKEditor','',$template->content,array('editorType'=>'basic'));

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formMailing',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.editmailing'),$title);

		$this->pageDisplay('tools');
	}
	public function editMailingTemplateSuccess($data) {
		$mailingTemplatesDB = new mailingtemplatesDB();
		$mailingTemplatesDB->updateRow($data, "id={$this->request->getVariable('id')}");
		router::reload();
	}
	public function addMailingContactGroup() {
		$form = new form('add','addMailingContactGroupSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'));
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formMailing',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.addcontact'),$title);

		$this->pageDisplay('tools');
	}
	public function addMailingContactGroupSuccess($data) {
		$contactgroupsDB = new contactgroupsDB();
		$contactgroupsDB->add($data);
		router::reload();
	}
	public function editMailingContactGroup() {
		$contactGroupDB = new contactgroupsDB();
		$contactGroup = $contactGroupDB->fetchRow("id={$this->request->getVariable('id')}");

		$form = new form('add','editMailingContactGroupSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'),$contactGroup->name);
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formMailing',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.editcontact'),$title);

		$this->pageDisplay('tools');
	}
	public function editMailingContactGroupSuccess($data) {
		$contactGroupDB = new contactgroupsDB();
		$contactGroupDB->updateRow($data,"id={$this->request->getVariable('id')}");
		router::reload();
	}
	public function addMailingContact() {
		$form = new form('add','addMailingContactSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'));
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->add('email', 'input-text',lang::read('admin.users.controller.email'),null,array());
		$form->addRule('email', 'required', null, lang::read('admin.users.controller.giveemail'));
		$form->addRule('email', 'email', null, lang::read('admin.users.controller.givecorrectemail'));

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formMailing',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.editcontact'),$title);

		$this->pageDisplay('tools');
	}
	public function addMailing() {
		foreach($this->mailingTemplatesList as $mailingTemplate){
			$mailingTemplateListArray[$mailingTemplate->id]=$mailingTemplate->name;
		}
		foreach($this->contactsGroups as $contactsGroup){
			$contactsGroupsArray[$contactsGroup->id]=$contactsGroup->name;
		}

		$form = new form('add','addMailingSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.tools.mailing.controller.mailingname'));
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->add('contactGroup', 'select',lang::read('admin.tools.mailing.controller.contactsgroup'),$page->type, array("option"=>$contactsGroupsArray));
		$form->add('contentId', 'select',lang::read('admin.tools.mailing.controller.template'),$page->type, array("option"=>$mailingTemplateListArray));

		$form->add('subject', 'input-text',lang::read('admin.tools.mailing.controller.subject'));
		$form->addRule('subject', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->add('from', 'input-text',lang::read('admin.tools.mailing.controller.senderemail'),$contact->email,array());
		$form->addRule('from', 'required', null, lang::read('admin.users.controller.giveemail'));
		$form->addRule('from', 'email', null, lang::read('admin.users.controller.givecorrectemail'));

		$form->add('senderName', 'input-text',lang::read('admin.tools.mailing.controller.sendername'));
		$form->addRule('senderName', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formMailing',$form);

		$this->pageDisplay('tools');
	}
	public function addMailingSuccess($data) {
		$data['replay'] = $data['from'];
		$data['return'] = $data['from'];

		$mailingsDB = new mailingsDB();
		$mailingsDB->add($data);
		router::reload();
	}	
	
	public function addMailingContactSuccess($data) {
		$contactDB = new contactDB();
		$contactDB->add($data,$this->request->getVariable('id'));
		router::reload();
	}

	public function addMailingMassContact() {
		$form = new form('add','addMailingMassContactSuccess',$_POST,'POST','form-horizontal');
		$form->add('emails', 'textarea',lang::read('admin.content.controller.elementname'));
		$form->addRule('emails', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formMailing',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.editcontact'),$title);

		$this->pageDisplay('tools');
	}
	public function addMailingMassContactSuccess($data) {
		$contactDB = new contactDB();

		$data['emails'] = str_replace(' ','',$data['emails']);
		$emailArray = explode(',', $data['emails']);
		$bucket = $this->request->getVariable('id');

		foreach ($emailArray as $email) {
			$emailData['email'] = $email;
			$contactDB->add($emailData,$bucket);
		}
		router::reload();
	}
		
	//////////////////////////////////////////////////////////////////////
	//Contact/////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////	
	public function addContact() {
		$form = new form('add','addMailingContactSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'));
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->add('email', 'input-text',lang::read('admin.users.controller.email'),null,array());
		$form->addRule('email', 'required', null, lang::read('admin.users.controller.giveemail'));
		$form->addRule('email', 'email', null, lang::read('admin.users.controller.givecorrectemail'));
		
		$form->add('telephone', 'input-text',lang::read('admin.tools.controller.telephone'));
		$form->add('mobile', 'input-text',lang::read('admin.tools.controller.mobile'));
		$form->add('adress', 'input-text',lang::read('admin.tools.controller.adress'));
		$form->add('city', 'input-text',lang::read('admin.tools.controller.city'));
		$form->add('code', 'input-text',lang::read('admin.tools.controller.code'));
		$form->add('country', 'input-text',lang::read('admin.tools.controller.country'));
		$form->add('taxid', 'input-text',lang::read('admin.tools.controller.taxid'));
		$form->add('other', 'input-text',lang::read('admin.tools.controller.other'));
		

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formContact',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.editcontact'),$title);

		$this->pageDisplay('tools');
	}	


	public function editContact() {
		$contactDB = new contactDB();
		$contact = $contactDB->fetchRow("id={$this->request->getVariable('id')}");
		$contactColumns = $contactDB->contactColumns;
		
		$form = new form('editContact','editContactSuccess',$_POST,'POST','form-horizontal');
		
		foreach ($contactColumns as $contactColumn){
			$form->add($contactColumn, 'input-text',$contactColumn,$contact->$contactColumn);
		}
		
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'),$contact->name);
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->add('email', 'input-text',lang::read('admin.users.controller.email'),$contact->email,array());
		$form->addRule('email', 'required', null, lang::read('admin.users.controller.giveemail'));
		$form->addRule('email', 'email', null, lang::read('admin.users.controller.givecorrectemail'));		
		
		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formContact',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.editcontact'),$title);

		$this->pageDisplay('tools');
	}	
	public function editMailingContact() {
		$contactDB = new contactDB();
		$contact = $contactDB->fetchRow("id={$this->request->getVariable('id')}");


		$form = new form('editMailingContact','editContactSuccess',$_POST,'POST','form-horizontal');

		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'),$contact->name);
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$form->add('email', 'input-text',lang::read('admin.users.controller.email'),$contact->email,array());
		$form->addRule('email', 'required', null, lang::read('admin.users.controller.giveemail'));
		$form->addRule('email', 'email', null, lang::read('admin.users.controller.givecorrectemail'));		

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formMailing',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.editcontact'),$title);

		$this->pageDisplay('tools');
	}
	public function editContactSuccess($data) {
		$contactDB = new contactDB();
		$contactDB->updateRow($data,"id={$this->request->getVariable('id')}");
		router::reload();
	}
	public function showMailingContact() {
		$pageCount = 15;

		$contactDB = new contactDB();
		$page = $pageCount*$this->request->getVariable('p');
		$emails = $contactDB->getEmails($this->request->getVariable('id'),0,"{$page},{$pageCount}");
		$emailsCount = $contactDB->getEmailsCount($this->request->getVariable('id'));

		$this->smarty->assign('emails',$emails);
		$this->smarty->assign('emailsCount',$emailsCount);
		$this->smarty->assign('pageCount',$pageCount);
		$this->pageDisplay('tools');
	}
	public function showContacts() {
		$pageCount = 15;

		$contactDB = new contactDB();
		$page = $pageCount*$this->request->getVariable('p');
		$emails = $contactDB->getEmails($this->request->getVariable('id'),0,"{$page},{$pageCount}",1,0,'*');
		$emailsCount = $contactDB->getEmailsCount($this->request->getVariable('id'));

		$this->smarty->assign('emails',$emails);
		$this->smarty->assign('emailsCount',$emailsCount);
		$this->smarty->assign('pageCount',$pageCount);
		$this->pageDisplay('tools');
	}	


	
	////////////////////////////////
	/////CSV export inport//////////
	////////////////////////////////
	public function exportToCSVContacts() {
		$contactDB = new contactDB();
		$emailsArray = $contactDB->getEmails($this->request->getVariable('id'),0,100000,1,0,$contactDB->contactColumns,PDO::FETCH_ASSOC);
		$contactGroupsDB = new contactgroupsDB();
		$contactGroup = $contactGroupsDB->fetchRow("id={$this->request->getVariable('id')}");
		
		array_unshift($emailsArray, $contactDB->contactColumns);

		csv::getCsvFile(generator::cleanFileName($contactGroup->name.'_'.generator::sqlDatetime()), $emailsArray);
	}		
	
	public function importContactGroup() {
		$form = new form('import','importContactGroupSuccess',$_POST,'POST','form-horizontal');
		$form->add('csvFile', 'input-file',lang::read('admin.tools.controller.csv'),null,array("tooltip" => lang::read('admin.tools.controller.csv.description')));	
		
		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formContact',$form);

		$this->pageDisplay('tools');
	}	
	public function importContactGroupSuccess($data) {
		if ($_FILES['csvFile']['error']==0) {
			$arrayFromCsv = csv::toArray($_FILES['csvFile']['tmp_name']);

			$contactDB = new contactDB();
			$contactGroupsDB = new contactgroupsDB();
			$contactGroupsDB->add(array('name'=>$_FILES['csvFile']['name']));
			
			$group = $contactGroupsDB->fetchRow("name = '{$_FILES['csvFile']['name']}'",'id DESC');
			unset($arrayFromCsv[0]);
			foreach ($arrayFromCsv as $row) {
				if (count($row)>=2) {
					$contactDB->add(array_combine($contactDB->contactColumns,$row), $group->id);
				}				
			}
			
		}
		router::reload();	
	}

	public function mergeContactGroup() {
		$contactGroupsDB = new contactgroupsDB();
		
		$form = new form('merge','mergeContactGroupSuccess',$_POST,'POST','form-horizontal');
		
		$form->add('list1', 'select',lang::read('admin.tools.mailing.controller.mailinglist').' 1',null,array('option' => $contactGroupsDB->getArray()));
		$form->add('list2', 'select',lang::read('admin.tools.mailing.controller.mailinglist').' 2',null,array('option' => $contactGroupsDB->getArray()));

		$form->setHandler($this);
		$form->handle();
		
		$this->smarty->assign('formContact',$form);

		$this->pageDisplay('tools');
	}	
	public function mergeContactGroupSuccess($data) {
		
		$groupId1 = $data['list1'];
		$groupId2 = $data['list2'];

		router::reload();	
	}	

	//////////////////////////////////////////////////////////////////////
	//Files///////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////		
	
	public function editFile() {
		$filesDB = new filesDB();
		$file = $filesDB->fetchRow("id={$this->request->getVariable('id')}");
		
		$form = new form('editFile','editFileSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'),$file->name);
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$form->add('file', 'input-file',lang::read('admin.tools.controller.file'),null,array("tooltip" => lang::read('admin.tools.controller.filedescription')));

		$form->setHandler($this);
		$form->handle();

		$this->smarty->assign('formEditFile',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.editcontact'),$title);

		$this->pageDisplay('tools');
	}
	public function editFileSuccess($data) {
		$filesDB = new filesDB();
		$filesDB->set($this->request->getVariable('id'),'name',$data['name']);
		
		if ($_FILES['file']['error']==0) {
			file::updateFile($this->request->getVariable('id'),$_FILES['file'],$data);
		}
		router::reload();
	}	
	
	//////////////////////////////////////////////////////////////////////
	//Images//////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////		
	public function editImage() {
		$imagesDB = new imagesDB();
		
		$image = $imagesDB->fetchRow("id={$this->request->getVariable('id')}");

		$form = new form('add','editImageSuccess',$_POST,'POST','form-horizontal');
		$form->add('name', 'input-text',lang::read('admin.content.controller.elementname'),$image->name);
		$form->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$form->add('file', 'input-file',lang::read('admin.tools.controller.newimage'),null,array("tooltip" => lang::read('admin.tools.controller.filedescription')));
		$form->add('description', 'textareaCKEditor','',$image->description,array('editorType'=>'minimal_source'));
			
		$form->setHandler($this);
		$form->handle();
		
		$this->smarty->assign('image',$image);
		$this->smarty->assign('formEditImage',$form);
		$this->smarty->assign(lang::read('admin.tools.controller.editcontact'),$title);
	
		$this->pageDisplay('tools');
	}
	public function editImageSuccess($data) {
		$imagesDB = new imagesDB();
		$imagesDB->set($this->request->getVariable('id'),'name',$data['name']);
		$imagesDB->set($this->request->getVariable('id'),'description',$data['description']);
		if ($_FILES['file']['error']==0) {
			
			image::updateImage($this->request->getVariable('id'),$_FILES['file'],$data);
		}
		router::reload();
	}
	////////////////////////////////
	/////DB explorer////////////////
	////////////////////////////////
	public function showTable() {
		$tableName = $this->request->getVariable('id');
		$this->smarty->assign('dbTableObject',new $tableName());
		$this->pageDisplay('tools');
	}
	public function editRow() {
		
		$tableName = $this->request->getVariable('id');
		$this->smarty->assign('dbTableObject',new $tableName());		
		
		$tableName = $this->request->getVariable('id');
		$rowId =  $this->request->getVariable('secoundId');
		
		$table = new $tableName();
		$row = $table->fetchRow("id={$rowId}");
		unset($row->id);
		
		$formEdit = new form('editRow','editRowSuccess',$_POST,'POST','form-horizontal');
		foreach ($row as $key=>$val){
			if ($key=='content' or $key=='description') {
				$formEdit->add($key, 'textarea',$key,$val);
			}else{
				$formEdit->add($key, 'input-text',$key,$val);
			}
						
		}
		$formEdit->setHandler($this);
		$formEdit->handle();
		
		
		$this->smarty->assign('formTableRowEdit',$formEdit);
		$this->pageDisplay('tools');
	}
	public function editRowSuccess($data) {
		$tableName = $this->request->getVariable('id');
		$rowId =  $this->request->getVariable('secoundId');
		$table = new $tableName();
		unset($data['id']);
		
		$table->updateRow($data, "id={$rowId}");
		router::reload();
	}

	////////////////////////////////
	/////Banners////////////////////
	////////////////////////////////	
	
	/////banner area////////////////////////////////
	
	public function addBannersArea() {
		$bannerAreaAddForm = new form('bannerAreaAdd','addBannersAreaSuccess',$_POST,'POST','form-horizontal');
		$bannerAreaAddForm->add('name', 'input-text',lang::read('admin.tools.controller.banners.name'));
		$bannerAreaAddForm->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerAreaAddForm->add('width', 'input-text',lang::read('admin.tools.controller.banners.width'));
		$bannerAreaAddForm->addRule('width', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerAreaAddForm->addRule('width', 'numeric', null,lang::read('validator.number'));
		$bannerAreaAddForm->add('height', 'input-text',lang::read('admin.tools.controller.banners.height'));
		$bannerAreaAddForm->addRule('height', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerAreaAddForm->addRule('height', 'numeric', null,lang::read('validator.number'));
		
		$bannerAreaAddForm->setHandler($this);
		$bannerAreaAddForm->handle();
		$this->smarty->assign('bannerAreaForm',$bannerAreaAddForm);
		$this->pageDisplay('tools');
	}
	public function addBannersAreaSuccess($data) {
		$bannersareaDB = new bannersareasDB();
		$bannersareaDB->add($data);
		router::reload();
	}	
	public function editBannerArea() {
		$bannerAreaDB = new bannersareasDB();
		$bannerArea = $bannerAreaDB->fetchRow("id={$this->request->getVariable('id')}");
		
		$bannerAreaEditForm = new form('bannerAreaEdit','editBannerAreaSuccess',$_POST,'POST','form-horizontal');
		$bannerAreaEditForm->add('name', 'input-text',lang::read('admin.tools.controller.banners.name'),$bannerArea->name);
		$bannerAreaEditForm->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerAreaEditForm->add('width', 'input-text',lang::read('admin.tools.controller.banners.width'),$bannerArea->width);
		$bannerAreaEditForm->addRule('width', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerAreaEditForm->addRule('width', 'numeric', null,lang::read('validator.number'));
		$bannerAreaEditForm->add('height', 'input-text',lang::read('admin.tools.controller.banners.height'),$bannerArea->height);
		$bannerAreaEditForm->addRule('height', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerAreaEditForm->addRule('height', 'numeric', null,lang::read('validator.number'));
		
		$bannerAreaEditForm->setHandler($this);
		$bannerAreaEditForm->handle();
		$this->smarty->assign('bannerAreaForm',$bannerAreaEditForm);
		$this->pageDisplay('tools');
	}
	public function editBannerAreaSuccess($data) {
		$bannersareaDB = new bannersareasDB();
		$bannersareaDB->update($data,$this->request->getVariable('id'));
		router::reload();
	}		
	
	/////banner////////////////////////////////
	
	public function addBanner() {
		$bannerAddForm = new form('bannerAdd','addBannerSuccess',$_POST,'POST','form-horizontal');
		$bannerAddForm->add('name', 'input-text',lang::read('admin.tools.controller.banners.bannername'));
		$bannerAddForm->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));
		
		$bannerAddForm->add('bannerFile', 'input-file',lang::read('admin.content.controller.image'),null,array("tooltip" => lang::read('admin.content.controller.imagedescription')));	
		$bannerAddForm->addRule('bannerFile', 'required', null,lang::read('admin.content.controller.giveelementname'));
		
		$bannerAddForm->add('link', 'input-text',lang::read('admin.tools.controller.banners.link'));
		$bannerAddForm->addRule('link', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerAddForm->addRule('link', 'url', null,lang::read('admin.content.controller.givecorrecturl'));
		
				
		$bannerAddForm->add('viewsLimit', 'input-text',lang::read('admin.tools.controller.banners.viewslimit'));
		$bannerAddForm->addRule('viewsLimit', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerAddForm->addRule('viewsLimit', 'numeric', null,lang::read('validator.number'));
		
		$bannerAddForm->add('clicksLimit', 'input-text',lang::read('admin.tools.controller.banners.clickslimit'));
		$bannerAddForm->addRule('clicksLimit', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerAddForm->addRule('clicksLimit', 'numeric', null,lang::read('validator.number'));
		
		$bannerAddForm->add('startDate', 'InputDataPicker',lang::read('admin.tools.controller.banners.startdate'));
		$bannerAddForm->addRule('startDate', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$bannerAddForm->add('endDate', 'InputDataPicker',lang::read('admin.tools.controller.banners.enddate'));
		$bannerAddForm->addRule('endDate', 'required', null,lang::read('admin.content.controller.giveelementname'));		
		
		$bannerAddForm->setHandler($this);
		$bannerAddForm->handle();
		$this->smarty->assign('bannerAreaForm',$bannerAddForm);
		$this->pageDisplay('tools');
	}
	public function addBannerSuccess($data) {
		$bannersDB = new bannersDB();
		$banner = $bannersDB->add($data,$this->request->getVariable('id'));
		unset($data);
		if ($_FILES['bannerFile']['error']==0) {
			file::deleteFileByBucket('banners-'.$banner->id);
			$file = file::saveIncomingFile($_FILES['bannerFile'],'banners-'.$banner->id);
			$data['fileEkey'] = $file['ekey'];
		}	
		$bannersDB->updateRow($data,"id={$banner->id}");		
		
		router::reload();
	}	
	public function editBanner() {
		$bannersDB = new bannersDB();
		$banner = $bannersDB->fetchRow("id={$this->request->getVariable('id')}");
		
		$bannerEditForm = new form('bannerEdit','editBannerSuccess',$_POST,'POST','form-horizontal');
		$bannerEditForm->add('name', 'input-text',lang::read('admin.tools.controller.banners.bannername'),$banner->name);
		$bannerEditForm->addRule('name', 'required', null,lang::read('admin.content.controller.giveelementname'));
		
		$bannerEditForm->add('bannerFile', 'input-file',lang::read('admin.content.controller.image'),null,array("tooltip" => lang::read('admin.content.controller.imagedescription')));	
		
		
		$bannerEditForm->add('link', 'input-text',lang::read('admin.tools.controller.banners.link'),$banner->link);
		$bannerEditForm->addRule('link', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerEditForm->addRule('link', 'url', null,lang::read('admin.content.controller.givecorrecturl'));
				
		$bannerEditForm->add('viewsLimit', 'input-text',lang::read('admin.tools.controller.banners.viewslimit'),$banner->viewsLimit);
		$bannerEditForm->addRule('viewsLimit', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerEditForm->addRule('viewsLimit', 'numeric', null,lang::read('validator.number'));
		
		$bannerEditForm->add('clicksLimit', 'input-text',lang::read('admin.tools.controller.banners.clickslimit'),$banner->clicksLimit);
		$bannerEditForm->addRule('clicksLimit', 'required', null,lang::read('admin.content.controller.giveelementname'));
		$bannerEditForm->addRule('clicksLimit', 'numeric', null,lang::read('validator.number'));
		
		$bannerEditForm->add('startDate', 'InputDataPicker',lang::read('admin.tools.controller.banners.startdate'),$banner->startDate);
		$bannerEditForm->addRule('startDate', 'required', null,lang::read('admin.content.controller.giveelementname'));

		$bannerEditForm->add('endDate', 'InputDataPicker',lang::read('admin.tools.controller.banners.enddate'),$banner->endDate);
		$bannerEditForm->addRule('endDate', 'required', null,lang::read('admin.content.controller.giveelementname'));	
		
		$bannerEditForm->setHandler($this);
		$bannerEditForm->handle();
		$this->smarty->assign('bannerForm',$bannerEditForm);
		$this->pageDisplay('tools');
	}
	public function editBannerSuccess($data) {
		$bannerDB = new bannersDB();

		if ($_FILES['bannerFile']['error']==0) {
			file::deleteFileByBucket('banners-'.$this->request->getVariable('id'));
			$file = file::saveIncomingFile($_FILES['bannerFile'],'banners-'.$this->request->getVariable('id'));
			$data['fileEkey'] = $file['ekey'];
		}	
		$bannerDB->updateRow($data,"id={$this->request->getVariable('id')}");
				
		router::reload();
	}	

	////////////////////////////////
	/////Monitoring/////////////////
	////////////////////////////////		
	
	public function showStatChart() {
		$chartType = $this->request->getVariable('id');
		$this->smarty->assign('chartType',$chartType);
		$this->pageDisplay('tools');
		
	}
}
?>
