<?php /*windu.org front controller*/
Class frontDoController Extends controller{
	public function __construct(request $request){
		lang::set('front');
		parent::__construct($request);
	}
	public function setLanguage() {
		$langId = intval($this->request->getVariable('first'));
		
		if (is_numeric($langId)) {
			$pagesDB = new pagesDB();
			if($pagesDB->fetchCount("id=$langId")==1){
				cookie::setCookie('lang-front',$langId,1209600);
			}
		}
		router::redirect('front');
	}	
	public function rate(){
		
		$ratesDB = new ratesDB();
		$usersDB = new usersDB();
		
		$table = generator::clean($this->request->getVariable('first'));
		$ekey = generator::clean($this->request->getVariable('secound'));
		$rate = generator::clean($this->request->getVariable('third'));
		
		$tableDB = new $table();
		$id = $tableDB->getByEkey($ekey)->id;
		
		if ($ratesDB->checkUnique($id,$table)) {
			
			$data['rate'] = $rate;
			$data['elementId'] = $id;
			$data['userId'] = $usersDB->getLoggedIn()->id;
			$data['bucket'] = $table;
			
			$ratesDB->add($data);
			echo lang::read('rate.message.positive');
			return true;
		}
		echo lang::read('rate.message.negative');
		return false;
	}
	public function activateUser() {
		$sessionDB = new sessionDB();
		$usersDB = new usersDB();
		$userEmail = $sessionDB->get(generator::clean($this->request->getVariable('first')));
		if ($userEmail!=null) {
			$usersDB->activateByEmail($userEmail);
			$sessionDB->delete(generator::clean($this->request->getVariable('first')));
			router::redirect('front',array('mp'=>'front.user.activate'));
		}
		router::redirect('front',array('mn'=>'front.user.keynotexists'));
	}

	public function resetAdminPassword() {
		self::resetPassword('admin');
	}	
	public function resetUserPassword() {
		self::resetPassword('front');
	}	
	private function resetPassword($redirect = 'front') {
		$sessionDB = new sessionDB();
		$usersDB = new usersDB();
		$userEmail = $sessionDB->get($this->request->getVariable('first'),true,true);
		$user = $usersDB->fetchRow("email = '{$userEmail}'");
		
		if ($user!=null) {
			$sessionDB->delete(generator::clean($this->request->getVariable('first')));
			$sessionDB->set($data, $expire);

			router::redirect($redirect,array('mp'=>'front.user.activate'));
		}
		
		router::redirect($redirect,array('mn'=>'front.user.keynotexists'));
	}			
	public function logout() {
		$usersDB = new usersDB();
		$usersDB->logout();
		router::back($this->request);
	}
	public function deleteUserImage(){
		$usersDB = new usersDB();
		$user = $usersDB->getLoggedIn();
		image::deleteImageByBucket('user-'.$user->id);
		router::back($this->request);
	}		
}
?>
