<?php /*windu.org model*/
Class userRegisterController extends widgetSmartyMainController
{		
	public function run() {
		$usersDB = new usersDB();
		$user = $usersDB->getLoggedIn();
		if ($user!=null) {
			router::redirect('front');
		}
		
		$userPageForm = new form('registerUser','registerUserSuccess',$_POST,'POST','form-horizontal');
		$userPageForm->add('email', 'input-text',lang::read('user.register.email'),null,array());
		$userPageForm->addRule('email', 'required', null, lang::read('user.register.giveemail'));	
		$userPageForm->addRule('email', 'email', null, lang::read('user.register.givecorrectmail'));	
		$userPageForm->addRule('email', 'unique', array('table'=>$usersDB), lang::read('user.register.emailtaken'));
		
		$userPageForm->add('password', 'input-password',lang::read('user.register.password'),null,array("tooltip" => lang::read('user.register.autogener')));
		$userPageForm->addRule('password', 'string', array(6,50),lang::read('user.register.toshortpass'));	
		$userPageForm->addRule('password', 'same','passwordCompare',lang::read('user.register.diffpasswords'));
		$userPageForm->add('passwordCompare', 'input-password',lang::read('user.register.repeatpassword'),null);
		
		$userPageForm->add('username', 'input-text',lang::read('user.register.username'),null,array("tooltip" => lang::read('user.register.shownname'),"placeholder" => lang::read('user.register.kowal')));
		$userPageForm->add('name', 'input-text',lang::read('user.register.name'),null,array("placeholder" => lang::read('user.register.jan')));
		$userPageForm->add('surname', 'input-text',lang::read('user.register.surname'),null,array("placeholder" => lang::read('user.register.kowalski')));
		
		$userPageForm->addButton('submit',lang::read('user.register.register'));	
		
		$userPageForm->setHandler($this);
		$userPageForm->handle();

		return array("form" => $userPageForm);
	}
	public function registerUserSuccess($data) {
		$template = config::get('template');
		
		$finishData['type'] = 14;
		$finishData['email'] = $data['email'];
		$finishData['password'] = generator::sqlInjesctionStringSecure($data['password']);
		$finishData['username'] = generator::sqlInjesctionStringSecure($data['username']);
		$finishData['name'] = generator::sqlInjesctionStringSecure($data['name']);
		$finishData['surname'] = generator::sqlInjesctionStringSecure($data['surname']);
		
		$usersDB = new usersDB();
		$user = $usersDB->add($finishData,config::get('userActive'));
		if (config::get('userMailActivation')) {
			$sessionDB = new sessionDB();
			$sessionKey = $sessionDB->set($user['email'], 259200);
			
			$this->smarty->assign('user',$user);
			$this->smarty->assign('sessionKey',$sessionKey);
			
			mail::send($user['email'], lang::read('user.register.activate.account'), $this->smarty->fetch('register_mail.tpl'),$user['email']);
		}
		
		$pagesDB = new pagesDB();
		$pageUrlKey = $pagesDB->get($this->params['successPage'],'urlKey');		
		$redirectUrl = HOME.$pageUrlKey;
		
		router::redirect($redirectUrl);
	}		
}
?>